import sqlite3 as lite
import sys
import bd.utiles as utiles

class ModeloBDMapper(object):

	def getObject(self, oid):
		con = utiles.connectBD()
		
		with con:
			con.row_factory = lite.Row

			cur = con.cursor()
			cur.execute("SELECT * FROM modelo WHERE nombre='%s'" % (oid))
			
			row = cur.fetchone()

			modelo = self.__mapToObject(row)
			
			return modelo
			
	def getAll(self):
		con = utiles.connectBD()
		
		with con:
			con.row_factory = lite.Row

			cur = con.cursor() 
			cur.execute("SELECT * FROM modelo")

			rows = cur.fetchall()
			
			modelosList = []
			for row in rows:
				modelosList.append(self.__mapToObject(row))

			return modelosList
			
		
	def putObject(self, obj):
		
		con = utiles.connectBD()
		
		try:
			cur = con.cursor()
			
			sql = "INSERT INTO modelo\
					VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s');" % (
						obj.nombre, obj.arquitectura, obj.instalacion, 
						obj.entornoGrafico, obj.ubicacionImg, obj.username, obj.hostname, obj.estado)
			
			cur.execute(sql)
			con.commit()
			
		except lite.IntegrityError, e:
			raise
		finally:
			if con:
				con.close()
		
		
	def updateObject(self, obj):
	
		con = utiles.connectBD()

		try:
			cur = con.cursor()

			sql= "UPDATE modelo\
				SET nombre='%s', arquitectura='%s', instalacion='%s',\
				entornoGrafico='%s', ubicacionImg='%s', username='%s', hostname='%s', estado='%s'\
				WHERE nombre='%s';" % (
			obj.nuevoNombre, obj.arquitectura, obj.instalacion, 
			obj.entornoGrafico, obj.ubicacionImg, obj.username, obj.hostname, obj.estado, obj.nombre)

			cur.execute(sql)
			con.commit()
			
		except lite.IntegrityError, e:
			raise
		finally:
			if con:
				con.close()

	def __mapToObject(self, row):
		modelo = Modelo()
		modelo.nombre = row["nombre"]
		modelo.arquitectura = row["arquitectura"]
		modelo.instalacion = row["instalacion"]
		modelo.entornoGrafico = row["entornoGrafico"]
		modelo.ubicacionImg = row["ubicacionImg"]
		modelo.username = row["username"]
		modelo.hostname = row["hostname"]
		modelo.estado = row["estado"]
		return modelo

from model.modelo import Modelo
