import sqlite3 as lite
import sys
import bd.utiles as utiles

class PerfilBDMapper:

	def putObject(self, obj):
		
		con = utiles.connectBD()
		
		try:
			cur = con.cursor()
			
			sql = "INSERT INTO perfil\
					VALUES ('%s', %s, '%s', '%s');" % (
						obj.nombre, 'NULL', obj.estado, obj.modelo)
			
			cur.execute(sql)
			con.commit()
			
		except lite.IntegrityError, e:
			raise
		finally:
			if con:
				con.close()
	
	
	def getAll(self):
	
		con = utiles.connectBD()
	
		with con:
			con.row_factory = lite.Row

			cur = con.cursor() 
			cur.execute("SELECT * FROM perfil ORDER BY nombre_mod")

			rows = cur.fetchall()
		
			perfilesList = []
			for row in rows:
				perfilesList.append(self.__mapToObject(row))

			return perfilesList
		
			
	def getObject(self, oid):
		
		con = utiles.connectBD()
		
		with con:
			con.row_factory = lite.Row

			cur = con.cursor()
			cur.execute("SELECT * FROM perfil WHERE nombre='%s'" % (oid))
			
			row = cur.fetchone()

			perfil = self.__mapToObject(row)
			
			return perfil
		
		
	def updateObject(self, obj):
	
		con = utiles.connectBD()

		try:
			cur = con.cursor()

			sql= "UPDATE perfil\
				SET nombre='%s', nombre_mod='%s'\
				WHERE nombre='%s';" % (
			obj.nuevoNombre, obj.modelo, obj.nombre)

			cur.execute(sql)
		
			sql= "UPDATE paquete\
			SET nombre_per='%s'\
			WHERE nombre_per='%s';" % (
			obj.nuevoNombre, obj.nombre)

			cur.execute(sql)
			
			con.commit()
			
		except lite.IntegrityError, e:
			raise
		finally:
			if con:
				con.close()
		
	
	
	
	"""		MAPEO DE LOS PAQUETES A BD		"""	
	
	def putPaquete(self, paquete):
		con = utiles.connectBD()
	
		with con:
			cur = con.cursor()
			
			sql = "INSERT INTO paquete\
					VALUES (%s, '%s', %s, '%s');" % (
						'NULL', paquete["nombre"], 'NULL', paquete["perfil"])
		
			cur.execute(sql)
			
			
	def getAllPaquetes(self, per):
		#Recupera todos los paquetes de un determinado perfil.
		
		con = utiles.connectBD()
	
		with con:
			con.row_factory = lite.Row

			cur = con.cursor() 
			cur.execute("SELECT * FROM paquete WHERE nombre_per='%s'" % (per.nombre))

			rows = cur.fetchall()

			return rows
	
	
	def deletePaquete(self, idPaquete):
		
		con = utiles.connectBD()

		with con:
			cur = con.cursor()

			sql= "DELETE FROM paquete WHERE idPaquete='%s';" % (idPaquete)

			cur.execute(sql)
				
		
	def __mapToObject(self, row):
		perfil = Perfil()
		perfil.nombre = row["nombre"]
		perfil.modelo = row["nombre_mod"]
		perfil.estado = row["estado"]
		return perfil

from model.perfil import Perfil
